/[gentoo-x86]/eclass/flag-o-matic.eclass
Gentoo

Diff of /eclass/flag-o-matic.eclass

Parent Directory Parent Directory | Revision Log Revision Log | View Patch Patch

Revision 1.11 Revision 1.131
1# Copyright 1999-2002 Gentoo Technologies, Inc. 1# Copyright 1999-2009 Gentoo Foundation
2# Distributed under the terms of the GNU General Public License v2 2# Distributed under the terms of the GNU General Public License v2
3# Author Bart Verwilst <verwilst@gentoo.org>
4# $Header: /var/cvsroot/gentoo-x86/eclass/flag-o-matic.eclass,v 1.11 2002/12/22 12:11:56 cretin Exp $ 3# $Header: /var/cvsroot/gentoo-x86/eclass/flag-o-matic.eclass,v 1.131 2009/01/08 11:29:06 gengor Exp $
5 4
6ECLASS=flag-o-matic 5# @ECLASS: flag-o-matic.eclass
7INHERITED="$INHERITED $ECLASS" 6# @MAINTAINER:
7# toolchain@gentoo.org
8# @BLURB: common functions to manipulate and query toolchain flags
9# @DESCRIPTION:
10# This eclass contains a suite of functions to help developers sanely
11# and safely manage toolchain flags in their builds.
8 12
13inherit eutils toolchain-funcs multilib
14
15################ DEPRECATED functions ################
16# The following are still present to avoid breaking existing
17# code more than necessary; however they are deprecated. Please
18# use gcc-specs-* from toolchain-funcs.eclass instead, if you
19# need to know which hardened techs are active in the compiler.
20# See bug #100974
9# 21#
10#### filter-flags <flag> #### 22# has_hardened
11# Remove particular flags from C[XX]FLAGS 23# has_pie
12# 24# has_pic
13#### append-flags <flag> #### 25# has_ssp_all
14# Add extra flags to your current C[XX]FLAGS 26# has_ssp
15#
16#### replace-flags <orig.flag> <new.flag> ###
17# Replace a flag by another one
18#
19#### is-flag <flag> ####
20# Returns "true" if flag is set in C[XX]FLAGS
21# Matches only complete flag
22#
23#### strip-flags ####
24# Strip C[XX]FLAGS of everything except known
25# good options.
26#
27#### get-flag <flag> ####
28# Find and echo the value for a particular flag
29#
30 27
28
29# {C,CXX,F,FC}FLAGS that we allow in strip-flags
30# Note: shell globs and character lists are allowed
31setup-allowed-flags() {
32 if [[ -z ${ALLOWED_FLAGS} ]] ; then
33 export ALLOWED_FLAGS="-pipe"
34 export ALLOWED_FLAGS="${ALLOWED_FLAGS} -O -O0 -O1 -O2 -mcpu -march -mtune"
35 export ALLOWED_FLAGS="${ALLOWED_FLAGS} -fstack-protector -fstack-protector-all"
36 export ALLOWED_FLAGS="${ALLOWED_FLAGS} -fbounds-checking -fno-strict-overflow"
37 export ALLOWED_FLAGS="${ALLOWED_FLAGS} -fno-PIE -fno-pie -fno-unit-at-a-time"
38 export ALLOWED_FLAGS="${ALLOWED_FLAGS} -g -g[0-9] -ggdb -ggdb[0-9] -gstabs -gstabs+"
39 export ALLOWED_FLAGS="${ALLOWED_FLAGS} -fno-ident"
40 export ALLOWED_FLAGS="${ALLOWED_FLAGS} -W* -w"
41 fi
42 # allow a bunch of flags that negate features / control ABI
43 ALLOWED_FLAGS="${ALLOWED_FLAGS} -fno-stack-protector -fno-stack-protector-all \
44 -fno-strict-aliasing -fno-bounds-checking -fstrict-overflow"
45 ALLOWED_FLAGS="${ALLOWED_FLAGS} -mregparm -mno-app-regs -mapp-regs \
46 -mno-mmx -mno-sse -mno-sse2 -mno-sse3 -mno-3dnow \
47 -mips1 -mips2 -mips3 -mips4 -mips32 -mips64 -mips16 \
48 -msoft-float -mno-soft-float -mhard-float -mno-hard-float -mfpu \
49 -mieee -mieee-with-inexact -mschedule \
50 -mtls-direct-seg-refs -mno-tls-direct-seg-refs \
51 -mflat -mno-flat -mno-faster-structs -mfaster-structs \
52 -m32 -m64 -mabi -mlittle-endian -mbig-endian -EL -EB -fPIC \
53 -mlive-g0 -mcmodel -mstack-bias -mno-stack-bias \
54 -msecure-plt -m*-toc -D* -U*"
55
56 # {C,CXX,F,FC}FLAGS that we are think is ok, but needs testing
57 # NOTE: currently -Os have issues with gcc3 and K6* arch's
58 export UNSTABLE_FLAGS="-Os -O3 -freorder-blocks"
59 return 0
60}
61
62# inverted filters for hardened compiler. This is trying to unpick
63# the hardened compiler defaults.
64_filter-hardened() {
65 local f
66 for f in "$@" ; do
67 case "${f}" in
68 # Ideally we should only concern ourselves with PIE flags,
69 # not -fPIC or -fpic, but too many places filter -fPIC without
70 # thinking about -fPIE.
71 -fPIC|-fpic|-fPIE|-fpie|-Wl,pie|-pie)
72 gcc-specs-pie || continue
73 is-flagq -nopie || append-flags -nopie;;
74 -fstack-protector)
75 gcc-specs-ssp || continue
76 is-flagq -fno-stack-protector || append-flags $(test-flags -fno-stack-protector);;
77 -fstack-protector-all)
78 gcc-specs-ssp-to-all || continue
79 is-flagq -fno-stack-protector-all || append-flags $(test-flags -fno-stack-protector-all);;
80 -fno-strict-overflow)
81 gcc-specs-nostrict || continue
82 is-flagq -fstrict-overflow || append-flags $(test-flags -fstrict-overflow);;
83 esac
84 done
85}
86
87# Remove occurrences of strings from variable given in $1
88# Strings removed are matched as globs, so for example
89# '-O*' would remove -O1, -O2 etc.
90_filter-var() {
91 local f x VAR VAL
92 declare -a new
93
94 VAR=$1
95 shift
96 eval VAL=\${${VAR}}
97 for f in ${VAL}; do
98 for x in "$@"; do
99 # Note this should work with globs like -O*
100 [[ ${f} == ${x} ]] && continue 2
101 done
102 eval new\[\${\#new\[@]}]=\${f}
103 done
104 eval export ${VAR}=\${new\[*]}
105}
106
107# @FUNCTION: filter-flags
108# @USAGE: <flags>
109# @DESCRIPTION:
110# Remove particular <flags> from {C,CPP,CXX,F,FC}FLAGS. Accepts shell globs.
31filter-flags () { 111filter-flags() {
112 _filter-hardened "$@"
113 _filter-var CFLAGS "$@"
114 _filter-var CPPFLAGS "$@"
115 _filter-var CXXFLAGS "$@"
116 _filter-var FFLAGS "$@"
117 _filter-var FCFLAGS "$@"
118 return 0
119}
32 120
33 for x in $1 121# @FUNCTION: filter-lfs-flags
34 do 122# @DESCRIPTION:
123# Remove flags that enable Large File Support.
124filter-lfs-flags() {
125 [[ -n $@ ]] && die "filter-lfs-flags takes no arguments"
126 filter-flags -D_FILE_OFFSET_BITS=64 -D_LARGEFILE_SOURCE -D_LARGEFILE64_SOURCE
127}
128
129# @FUNCTION: append-cppflags
130# @USAGE: <flags>
131# @DESCRIPTION:
132# Add extra <flags> to the current CPPFLAGS.
133append-cppflags() {
134 [[ -z $* ]] && return 0
135 export CPPFLAGS="${CPPFLAGS} $*"
136 return 0
137}
138
139# @FUNCTION: append-fflags
140# @USAGE: <flags>
141# @DESCRIPTION:
142# Add extra <flags> to the current {F,FC}FLAGS.
143append-fflags() {
144 [[ -z $* ]] && return 0
145 export FFLAGS="${FFLAGS} $*"
35 export CFLAGS="${CFLAGS/${x}}" 146 export FCFLAGS="${FCFLAGS} $*"
36 export CXXFLAGS="${CXXFLAGS/${x}}" 147 return 0
37 done
38
39} 148}
40 149
150# @FUNCTION: append-lfs-flags
151# @DESCRIPTION:
152# Add flags that enable Large File Support.
153append-lfs-flags() {
154 [[ -n $@ ]] && die "append-lfs-flags takes no arguments"
155 append-cppflags -D_FILE_OFFSET_BITS=64 -D_LARGEFILE_SOURCE -D_LARGEFILE64_SOURCE
156}
157
158# @FUNCTION: append-flags
159# @USAGE: <flags>
160# @DESCRIPTION:
161# Add extra <flags> to your current {C,CXX,F,FC}FLAGS.
41append-flags () { 162append-flags() {
42 163 [[ -z $* ]] && return 0
43 CFLAGS="${CFLAGS} $1" 164 export CFLAGS="${CFLAGS} $*"
44 CXXFLAGS="${CXXFLAGS} $1" 165 export CXXFLAGS="${CXXFLAGS} $*"
45 166 export FFLAGS="${FFLAGS} $*"
167 export FCFLAGS="${FCFLAGS} $*"
168 return 0
46} 169}
47 170
171# @FUNCTION: replace-flags
172# @USAGE: <old> <new>
173# @DESCRIPTION:
174# Replace the <old> flag with <new>. Accepts shell globs for <old>.
48replace-flags () { 175replace-flags() {
176 [[ $# != 2 ]] \
177 && echo && eerror "Usage: replace-flags <old flag> <new flag>" \
178 && die "replace-flags takes 2 arguments, not $#"
49 179
50 CFLAGS="${CFLAGS/${1}/${2} }" 180 local f fset
51 CXXFLAGS="${CXXFLAGS/${1}/${2} }" 181 declare -a new_CFLAGS new_CXXFLAGS new_FFLAGS new_FCFLAGS
52 182
53} 183 for fset in CFLAGS CXXFLAGS FFLAGS FCFLAGS; do
184 # Looping over the flags instead of using a global
185 # substitution ensures that we're working with flag atoms.
186 # Otherwise globs like -O* have the potential to wipe out the
187 # list of flags.
188 for f in ${!fset}; do
189 # Note this should work with globs like -O*
190 [[ ${f} == ${1} ]] && f=${2}
191 eval new_${fset}\[\${\#new_${fset}\[@]}]=\${f}
192 done
193 eval export ${fset}=\${new_${fset}\[*]}
194 done
54 195
196 return 0
197}
198
199# @FUNCTION: replace-cpu-flags
200# @USAGE: <old> <new>
201# @DESCRIPTION:
202# Replace cpu flags (like -march/-mcpu/-mtune) that select the <old> cpu
203# with flags that select the <new> cpu. Accepts shell globs for <old>.
204replace-cpu-flags() {
205 local newcpu="$#" ; newcpu="${!newcpu}"
206 while [ $# -gt 1 ] ; do
207 # quote to make sure that no globbing is done (particularly on
208 # ${oldcpu}) prior to calling replace-flags
209 replace-flags "-march=${1}" "-march=${newcpu}"
210 replace-flags "-mcpu=${1}" "-mcpu=${newcpu}"
211 replace-flags "-mtune=${1}" "-mtune=${newcpu}"
212 shift
213 done
214 return 0
215}
216
217_is_flagq() {
218 local x
219 for x in ${!1} ; do
220 [[ ${x} == $2 ]] && return 0
221 done
222 return 1
223}
224
225# @FUNCTION: is-flagq
226# @USAGE: <flag>
227# @DESCRIPTION:
228# Returns shell true if <flag> is in {C,CXX,F,FC}FLAGS, else returns shell false. Accepts shell globs.
229is-flagq() {
230 [[ -n $2 ]] && die "Usage: is-flag <flag>"
231 _is_flagq CFLAGS $1 || _is_flagq CXXFLAGS $1 || _is_flagq FFLAGS $1 || _is_flagq FCFLAGS $1
232}
233
234# @FUNCTION: is-flag
235# @USAGE: <flag>
236# @DESCRIPTION:
237# Echo's "true" if flag is set in {C,CXX,F,FC}FLAGS. Accepts shell globs.
55is-flag() { 238is-flag() {
239 is-flagq "$@" && echo true
240}
56 241
57 for x in ${CFLAGS} ${CXXFLAGS} 242# @FUNCTION: is-ldflagq
243# @USAGE: <flag>
244# @DESCRIPTION:
245# Returns shell true if <flag> is in LDFLAGS, else returns shell false. Accepts shell globs.
246is-ldflagq() {
247 [[ -n $2 ]] && die "Usage: is-ldflag <flag>"
248 _is_flagq LDFLAGS $1
249}
250
251# @FUNCTION: is-ldflag
252# @USAGE: <flag>
253# @DESCRIPTION:
254# Echo's "true" if flag is set in LDFLAGS. Accepts shell globs.
255is-ldflag() {
256 is-ldflagq "$@" && echo true
257}
258
259# @FUNCTION: filter-mfpmath
260# @USAGE: <math types>
261# @DESCRIPTION:
262# Remove specified math types from the fpmath flag. For example, if the user
263# has -mfpmath=sse,386, running `filter-mfpmath sse` will leave the user with
264# -mfpmath=386.
265filter-mfpmath() {
266 local orig_mfpmath new_math prune_math
267
268 # save the original -mfpmath flag
269 orig_mfpmath=$(get-flag -mfpmath)
270 # get the value of the current -mfpmath flag
271 new_math=$(get-flag mfpmath)
272 new_math=" ${new_math//,/ } "
273 # figure out which math values are to be removed
274 prune_math=""
275 for prune_math in "$@" ; do
276 new_math=${new_math/ ${prune_math} / }
58 do 277 done
59 if [ "${x}" = "$1" ] 278 new_math=$(echo ${new_math})
60 then 279 new_math=${new_math// /,}
61 echo true
62 break
63 fi
64 done
65 280
281 if [[ -z ${new_math} ]] ; then
282 # if we're removing all user specified math values are
283 # slated for removal, then we just filter the flag
284 filter-flags ${orig_mfpmath}
285 else
286 # if we only want to filter some of the user specified
287 # math values, then we replace the current flag
288 replace-flags ${orig_mfpmath} -mfpmath=${new_math}
289 fi
290 return 0
66} 291}
67 292
293# @FUNCTION: strip-flags
294# @DESCRIPTION:
295# Strip C[XX]FLAGS of everything except known good/safe flags.
68strip-flags() { 296strip-flags() {
297 local x y flag NEW_CFLAGS NEW_CXXFLAGS NEW_FFLAGS NEW_FCFLAGS
298
299 setup-allowed-flags
69 300
70 local NEW_CFLAGS="" 301 local NEW_CFLAGS=""
71 local NEW_CXXFLAGS="" 302 local NEW_CXXFLAGS=""
303 local NEW_FFLAGS=""
304 local NEW_FCFLAGS=""
72 305
73 local ALLOWED_FLAGS="-O -mcpu -march -pipe -g" 306 # Allow unstable C[XX]FLAGS if we are using unstable profile ...
307 if has ~$(tc-arch) ${ACCEPT_KEYWORDS} ; then
308 ALLOWED_FLAGS="${ALLOWED_FLAGS} ${UNSTABLE_FLAGS}"
309 fi
74 310
75 set -f 311 set -f # disable pathname expansion
76 312
77 for x in ${CFLAGS} 313 for x in ${CFLAGS}; do
78 do
79 for y in ${ALLOWED_FLAGS} 314 for y in ${ALLOWED_FLAGS}; do
80 do 315 flag=${x%%=*}
81 if [ "${x/${y}}" != "${x}" ] 316 if [ "${flag%%${y}}" = "" ] ; then
82 then
83 if [ -z "${NEW_CFLAGS}" ]
84 then
85 NEW_CFLAGS="${x}"
86 else
87 NEW_CFLAGS="${NEW_CFLAGS} ${x}" 317 NEW_CFLAGS="${NEW_CFLAGS} ${x}"
88 fi 318 break
89 fi 319 fi
90 done 320 done
91 done 321 done
92 322
93 for x in ${CXXFLAGS} 323 for x in ${CXXFLAGS}; do
94 do
95 for y in ${ALLOWED_FLAGS} 324 for y in ${ALLOWED_FLAGS}; do
96 do 325 flag=${x%%=*}
97 if [ "${x/${y}}" != "${x}" ] 326 if [ "${flag%%${y}}" = "" ] ; then
98 then
99 if [ -z "${NEW_CXXFLAGS}" ]
100 then
101 NEW_CXXFLAGS="${x}"
102 else
103 NEW_CXXFLAGS="${NEW_CXXFLAGS} ${x}" 327 NEW_CXXFLAGS="${NEW_CXXFLAGS} ${x}"
104 fi 328 break
105 fi 329 fi
106 done 330 done
107 done 331 done
108 332
109 set +f 333 for x in ${FFLAGS}; do
334 for y in ${ALLOWED_FLAGS}; do
335 flag=${x%%=*}
336 if [ "${flag%%${y}}" = "" ] ; then
337 NEW_FFLAGS="${NEW_FFLAGS} ${x}"
338 break
339 fi
340 done
341 done
342
343 for x in ${FCFLAGS}; do
344 for y in ${ALLOWED_FLAGS}; do
345 flag=${x%%=*}
346 if [ "${flag%%${y}}" = "" ] ; then
347 NEW_FCFLAGS="${NEW_FCFLAGS} ${x}"
348 break
349 fi
350 done
351 done
352
353 # In case we filtered out all optimization flags fallback to -O2
354 if [ "${CFLAGS/-O}" != "${CFLAGS}" -a "${NEW_CFLAGS/-O}" = "${NEW_CFLAGS}" ]; then
355 NEW_CFLAGS="${NEW_CFLAGS} -O2"
356 fi
357 if [ "${CXXFLAGS/-O}" != "${CXXFLAGS}" -a "${NEW_CXXFLAGS/-O}" = "${NEW_CXXFLAGS}" ]; then
358 NEW_CXXFLAGS="${NEW_CXXFLAGS} -O2"
359 fi
360 if [ "${FFLAGS/-O}" != "${FFLAGS}" -a "${NEW_FFLAGS/-O}" = "${NEW_FFLAGS}" ]; then
361 NEW_FFLAGS="${NEW_FFLAGS} -O2"
362 fi
363 if [ "${FCFLAGS/-O}" != "${FCFLAGS}" -a "${NEW_FCFLAGS/-O}" = "${NEW_FCFLAGS}" ]; then
364 NEW_FCFLAGS="${NEW_FCFLAGS} -O2"
365 fi
366
367 set +f # re-enable pathname expansion
110 368
111 export CFLAGS="${NEW_CFLAGS}" 369 export CFLAGS="${NEW_CFLAGS}"
112 export CXXFLAGS="${NEW_CXXFLAGS}" 370 export CXXFLAGS="${NEW_CXXFLAGS}"
371 export FFLAGS="${NEW_FFLAGS}"
372 export FCFLAGS="${NEW_FCFLAGS}"
373 return 0
113} 374}
114 375
376test-flag-PROG() {
377 local comp=$1
378 local flags="$2"
379
380 [[ -z ${comp} || -z ${flags} ]] && \
381 return 1
382
383 local PROG=$(tc-get${comp})
384 ${PROG} ${flags} -S -o /dev/null -xc /dev/null \
385 > /dev/null 2>&1
386}
387
388# @FUNCTION: test-flag-CC
389# @USAGE: <flag>
390# @DESCRIPTION:
391# Returns shell true if <flag> is supported by the C compiler, else returns shell false.
392test-flag-CC() { test-flag-PROG "CC" "$1"; }
393
394# @FUNCTION: test-flag-CXX
395# @USAGE: <flag>
396# @DESCRIPTION:
397# Returns shell true if <flag> is supported by the C++ compiler, else returns shell false.
398test-flag-CXX() { test-flag-PROG "CXX" "$1"; }
399
400# @FUNCTION: test-flag-F77
401# @USAGE: <flag>
402# @DESCRIPTION:
403# Returns shell true if <flag> is supported by the Fortran 77 compiler, else returns shell false.
404test-flag-F77() { test-flag-PROG "F77" "$1"; }
405
406# @FUNCTION: test-flag-FC
407# @USAGE: <flag>
408# @DESCRIPTION:
409# Returns shell true if <flag> is supported by the Fortran 90 compiler, else returns shell false.
410test-flag-FC() { test-flag-PROG "FC" "$1"; }
411
412test-flags-PROG() {
413 local comp=$1
414 local flags
415 local x
416
417 shift
418
419 [[ -z ${comp} ]] && return 1
420
421 x=""
422 for x in "$@" ; do
423 test-flag-${comp} "${x}" && flags="${flags}${flags:+ }${x}"
424 done
425
426 echo "${flags}"
427
428 # Just bail if we dont have any flags
429 [[ -n ${flags} ]]
430}
431
432# @FUNCTION: test-flags-CC
433# @USAGE: <flags>
434# @DESCRIPTION:
435# Returns shell true if <flags> are supported by the C compiler, else returns shell false.
436test-flags-CC() { test-flags-PROG "CC" "$@"; }
437
438# @FUNCTION: test-flags-CXX
439# @USAGE: <flags>
440# @DESCRIPTION:
441# Returns shell true if <flags> are supported by the C++ compiler, else returns shell false.
442test-flags-CXX() { test-flags-PROG "CXX" "$@"; }
443
444# @FUNCTION: test-flags-F77
445# @USAGE: <flags>
446# @DESCRIPTION:
447# Returns shell true if <flags> are supported by the Fortran 77 compiler, else returns shell false.
448test-flags-F77() { test-flags-PROG "F77" "$@"; }
449
450# @FUNCTION: test-flags-FC
451# @USAGE: <flags>
452# @DESCRIPTION:
453# Returns shell true if <flags> are supported by the Fortran 90 compiler, else returns shell false.
454test-flags-FC() { test-flags-PROG "FC" "$@"; }
455
456# @FUNCTION: test-flags
457# @USAGE: <flags>
458# @DESCRIPTION:
459# Short-hand that should hopefully work for both C and C++ compiler, but
460# its really only present due to the append-flags() abomination.
461test-flags() { test-flags-CC "$@"; }
462
463# @FUNCTION: test_flag
464# @DESCRIPTION:
465# DEPRICIATED, use test-flags()
466test_flag() {
467 ewarn "test_flag: deprecated, please use test-flags()!" >&2
468
469 test-flags-CC "$@"
470}
471
472# @FUNCTION: test_version_info
473# @USAGE: <version>
474# @DESCRIPTION:
475# Returns shell true if the current C compiler version matches <version>, else returns shell false.
476# Accepts shell globs.
477test_version_info() {
478 if [[ $($(tc-getCC) --version 2>&1) == *$1* ]]; then
479 return 0
480 else
481 return 1
482 fi
483}
484
485# @FUNCTION: strip-unsupported-flags
486# @DESCRIPTION:
487# Strip {C,CXX,F,FC}FLAGS of any flags not supported by the active toolchain.
488strip-unsupported-flags() {
489 export CFLAGS=$(test-flags-CC ${CFLAGS})
490 export CXXFLAGS=$(test-flags-CXX ${CXXFLAGS})
491 export FFLAGS=$(test-flags-F77 ${FFLAGS})
492 export FCFLAGS=$(test-flags-FC ${FCFLAGS})
493}
494
495# @FUNCTION: get-flag
496# @USAGE: <flag>
497# @DESCRIPTION:
498# Find and echo the value for a particular flag. Accepts shell globs.
115get-flag() { 499get-flag() {
116 local findflag="$1" 500 local f findflag="$1"
117 501
502 # this code looks a little flaky but seems to work for
503 # everything we want ...
504 # for example, if CFLAGS="-march=i686":
505 # `get-flag -march` == "-march=i686"
506 # `get-flag march` == "i686"
118 for f in ${CFLAGS} ${CXXFLAGS} ; do 507 for f in ${CFLAGS} ${CXXFLAGS} ${FFLAGS} ${FCFLAGS} ; do
119 if [ "${f/${findflag}}" != "${f}" ] ; then 508 if [ "${f/${findflag}}" != "${f}" ] ; then
120 echo "${f/-${findflag}=}" 509 printf "%s\n" "${f/-${findflag}=}"
121 return 510 return 0
122 fi 511 fi
123 done 512 done
513 return 1
124} 514}
515
516# @FUNCTION: has_hardened
517# @DESCRIPTION:
518# DEPRECATED - use gcc-specs-relro or gcc-specs-now from toolchain-funcs
519has_hardened() {
520 ewarn "has_hardened: deprecated, please use gcc-specs-{relro,now}()!" >&2
521
522 test_version_info Hardened && return 0
523 # The specs file wont exist unless gcc has GCC_SPECS support
524 [[ -f ${GCC_SPECS} && ${GCC_SPECS} != ${GCC_SPECS/hardened/} ]]
525}
526
527# @FUNCTION: has_pic
528# @DESCRIPTION:
529# DEPRECATED - use gcc-specs-pie from toolchain-funcs
530# indicate whether PIC is set
531has_pic() {
532 ewarn "has_pic: deprecated, please use gcc-specs-pie()!" >&2
533
534 [[ ${CFLAGS/-fPIC} != ${CFLAGS} || \
535 ${CFLAGS/-fpic} != ${CFLAGS} ]] || \
536 gcc-specs-pie
537}
538
539# @FUNCTION: has_pie
540# @DESCRIPTION:
541# DEPRECATED - use gcc-specs-pie from toolchain-funcs
542# indicate whether PIE is set
543has_pie() {
544 ewarn "has_pie: deprecated, please use gcc-specs-pie()!" >&2
545
546 [[ ${CFLAGS/-fPIE} != ${CFLAGS} || \
547 ${CFLAGS/-fpie} != ${CFLAGS} ]] || \
548 gcc-specs-pie
549}
550
551# @FUNCTION: has_ssp_all
552# @DESCRIPTION:
553# DEPRECATED - use gcc-specs-ssp from toolchain-funcs
554# indicate whether code for SSP is being generated for all functions
555has_ssp_all() {
556 ewarn "has_ssp_all: deprecated, please use gcc-specs-ssp()!" >&2
557
558 # note; this matches only -fstack-protector-all
559 [[ ${CFLAGS/-fstack-protector-all} != ${CFLAGS} || \
560 -n $(echo | $(tc-getCC) ${CFLAGS} -E -dM - | grep __SSP_ALL__) ]] || \
561 gcc-specs-ssp-to-all
562}
563
564# @FUNCTION: has_ssp
565# @DESCRIPTION:
566# DEPRECATED - use gcc-specs-ssp from toolchain-funcs
567# indicate whether code for SSP is being generated
568has_ssp() {
569 ewarn "has_ssp: deprecated, please use gcc-specs-ssp()!" >&2
570
571 # note; this matches both -fstack-protector and -fstack-protector-all
572 [[ ${CFLAGS/-fstack-protector} != ${CFLAGS} || \
573 -n $(echo | $(tc-getCC) ${CFLAGS} -E -dM - | grep __SSP__) ]] || \
574 gcc-specs-ssp
575}
576
577# @FUNCTION: has_m64
578# @DESCRIPTION:
579# This doesn't test if the flag is accepted, it tests if the flag actually
580# WORKS. Non-multilib gcc will take both -m32 and -m64. If the flag works
581# return code is 0, else the return code is 1.
582has_m64() {
583 # this doesnt test if the flag is accepted, it tests if the flag
584 # actually -WORKS-. non-multilib gcc will take both -m32 and -m64!
585 # please dont replace this function with test_flag in some future
586 # clean-up!
587
588 local temp="$(emktemp)"
589 echo "int main() { return(0); }" > "${temp}".c
590 MY_CC=$(tc-getCC)
591 ${MY_CC/ .*/} -m64 -o "$(emktemp)" "${temp}".c > /dev/null 2>&1
592 local ret=$?
593 rm -f "${temp}".c
594 [[ ${ret} != 1 ]] && return 0
595 return 1
596}
597
598# @FUNCTION: has_m32
599# @DESCRIPTION:
600# This doesn't test if the flag is accepted, it tests if the flag actually
601# WORKS. Non-mulilib gcc will take both -m32 and -64. If the flag works return
602# code is 0, else return code is 1.
603has_m32() {
604 # this doesnt test if the flag is accepted, it tests if the flag
605 # actually -WORKS-. non-multilib gcc will take both -m32 and -m64!
606 # please dont replace this function with test_flag in some future
607 # clean-up!
608
609 [ "$(tc-arch)" = "amd64" ] && has_multilib_profile && return 0
610
611 local temp=$(emktemp)
612 echo "int main() { return(0); }" > "${temp}".c
613 MY_CC=$(tc-getCC)
614 ${MY_CC/ .*/} -m32 -o "$(emktemp)" "${temp}".c > /dev/null 2>&1
615 local ret=$?
616 rm -f "${temp}".c
617 [[ ${ret} != 1 ]] && return 0
618 return 1
619}
620
621# @FUNCTION: replace-sparc64-flags
622# @DESCRIPTION:
623# Sets mcpu to v8 and uses the original value as mtune if none specified.
624replace-sparc64-flags() {
625 local SPARC64_CPUS="ultrasparc3 ultrasparc v9"
626
627 if [ "${CFLAGS/mtune}" != "${CFLAGS}" ]; then
628 for x in ${SPARC64_CPUS}; do
629 CFLAGS="${CFLAGS/-mcpu=${x}/-mcpu=v8}"
630 done
631 else
632 for x in ${SPARC64_CPUS}; do
633 CFLAGS="${CFLAGS/-mcpu=${x}/-mcpu=v8 -mtune=${x}}"
634 done
635 fi
636
637 if [ "${CXXFLAGS/mtune}" != "${CXXFLAGS}" ]; then
638 for x in ${SPARC64_CPUS}; do
639 CXXFLAGS="${CXXFLAGS/-mcpu=${x}/-mcpu=v8}"
640 done
641 else
642 for x in ${SPARC64_CPUS}; do
643 CXXFLAGS="${CXXFLAGS/-mcpu=${x}/-mcpu=v8 -mtune=${x}}"
644 done
645 fi
646
647 export CFLAGS CXXFLAGS
648}
649
650# @FUNCTION: append-ldflags
651# @USAGE: <flags>
652# @DESCRIPTION:
653# Add extra <flags> to the current LDFLAGS.
654append-ldflags() {
655 [[ -z $* ]] && return 0
656 local flag
657 for flag in "$@"; do
658 [[ ${flag} == -l* ]] && \
659 ewarn "Appending a library link instruction (${flag}); libraries to link to should not be passed through LDFLAGS"
660 done
661
662 export LDFLAGS="${LDFLAGS} $*"
663 return 0
664}
665
666# @FUNCTION: filter-ldflags
667# @USAGE: <flags>
668# @DESCRIPTION:
669# Remove particular <flags> from LDFLAGS. Accepts shell globs.
670filter-ldflags() {
671 _filter-var LDFLAGS "$@"
672 return 0
673}
674
675# @FUNCTION: raw-ldflags
676# @USAGE: <flags>
677# @DESCRIPTION:
678# Turn C style ldflags (-Wl,-foo) into straight ldflags - the results
679# are suitable for passing directly to 'ld'; note LDFLAGS is usually passed
680# to gcc where it needs the '-Wl,'.
681raw-ldflags() {
682 local x input="$@"
683 [[ -z ${input} ]] && input=${LDFLAGS}
684 set --
685 for x in ${input} ; do
686 x=${x#-Wl,}
687 set -- "$@" ${x//,/ }
688 done
689 echo "$@"
690}
691
692# @FUNCTION: bindnow-flags
693# @RETURN: Returns the flags to enable "now" binding in the current selected linker.
694# @DESCRIPTION:
695# DEPRECATED - Gets the flags needed for "NOW" binding
696bindnow-flags() {
697 ewarn "QA: stop using the bindnow-flags function ... simply drop it from your ebuild"
698}
699
700
701# Some tests for when we screw with things and want to make
702# sure we didn't break anything
703#TESTS() {
704# CFLAGS="-a -b -c=1"
705# CXXFLAGS="-x -y -z=2"
706# LDFLAGS="-l -m -n=3"
707#
708# die() { exit 1; }
709# (is-flag 1 2 3) && die
710# (is-ldflag 1 2 3) && die
711#
712# is-flagq -l && die
713# is-ldflagq -a && die
714# is-flagq -a || die
715# is-flagq -x || die
716# is-ldflagq -n=* || die
717# is-ldflagq -n && die
718#
719# strip-unsupported-flags
720# [[ ${CFLAGS} == "-c=1" ]] || die
721# [[ ${CXXFLAGS} == "-y -z=2" ]] || die
722#
723# echo "All tests pass"
724#}
725#TESTS

Legend:
Removed from v.1.11  
changed lines
  Added in v.1.131

  ViewVC Help
Powered by ViewVC 1.1.20